/* Auto-generated by genmsg_java.py for file /opt/ros/groovy/share/sensor_msgs/msg/RelativeHumidity.msg */

package ros.pkg.sensor_msgs.msg;

import java.nio.ByteBuffer;

public class RelativeHumidity extends ros.communication.Message {

  public ros.pkg.std_msgs.msg.Header header = new ros.pkg.std_msgs.msg.Header();
  public double relative_humidity;
  public double variance;

  public RelativeHumidity() {
  }

  public static java.lang.String __s_getDataType() { return "sensor_msgs/RelativeHumidity"; }
  public java.lang.String getDataType() { return __s_getDataType(); }
  public static java.lang.String __s_getMD5Sum() { return "8730015b05955b7e992ce29a2678d90f"; }
  public java.lang.String getMD5Sum() { return __s_getMD5Sum(); }
  public static java.lang.String __s_getMessageDefinition() { return " # Single reading from a relative humidity sensor.  Defines the ratio of partial\n" +
" # pressure of water vapor to the saturated vapor pressure at a temperature.\n" +
"\n" +
" Header header             # timestamp of the measurement\n" +
"                           # frame_id is the location of the humidity sensor\n" +
"\n" +
" float64 relative_humidity # Expression of the relative humidity\n" +
"                           # from 0.0 to 1.0.\n" +
"                           # 0.0 is no partial pressure of water vapor\n" +
"                           # 1.0 represents partial pressure of saturation\n" +
"\n" +
" float64 variance          # 0 is interpreted as variance unknown\n" +
"================================================================================\n" +
"MSG: std_msgs/Header\n" +
"# Standard metadata for higher-level stamped data types.\n" +
"# This is generally used to communicate timestamped data \n" +
"# in a particular coordinate frame.\n" +
"# \n" +
"# sequence ID: consecutively increasing ID \n" +
"uint32 seq\n" +
"#Two-integer timestamp that is expressed as:\n" +
"# * stamp.secs: seconds (stamp_secs) since epoch\n" +
"# * stamp.nsecs: nanoseconds since stamp_secs\n" +
"# time-handling sugar is provided by the client library\n" +
"time stamp\n" +
"#Frame this data is associated with\n" +
"# 0: no frame\n" +
"# 1: global frame\n" +
"string frame_id\n" +
"\n" +
""; }
  public java.lang.String getMessageDefinition() { return __s_getMessageDefinition(); }

  public RelativeHumidity clone() {
    RelativeHumidity c = new RelativeHumidity();
    c.deserialize(serialize(0));
    return c;
  }

  public void setTo(ros.communication.Message m) {
    deserialize(m.serialize(0));
  }

  public int serializationLength() {
    int __l = 0;
    __l += header.serializationLength();
    __l += 8; // relative_humidity
    __l += 8; // variance
    return __l;
  }

  public void serialize(ByteBuffer bb, int seq) {
    header.serialize(bb, seq);
    bb.putDouble(relative_humidity);
    bb.putDouble(variance);
  }

  public void deserialize(ByteBuffer bb) {
    header.deserialize(bb);
    relative_humidity = bb.getDouble();
    variance = bb.getDouble();
  }

  @SuppressWarnings("all")
  public boolean equals(Object o) {
    if(!(o instanceof RelativeHumidity))
      return false;
    RelativeHumidity other = (RelativeHumidity) o;
    return
      header.equals(other.header) &&
      relative_humidity == other.relative_humidity &&
      variance == other.variance &&
      true;
  }

  @SuppressWarnings("all")
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    long tmp;
    result = prime * result + (this.header == null ? 0 : this.header.hashCode());
    result = prime * result + (int)((tmp = Double.doubleToLongBits(this.relative_humidity)) ^ (tmp >>> 32));
    result = prime * result + (int)((tmp = Double.doubleToLongBits(this.variance)) ^ (tmp >>> 32));
    return result;
  }
} // class RelativeHumidity

